# 11. Container With Most Water

**<font color=red>难度: Medium</font>**

## 刷题内容

> 原题连接

* https://leetcode.com/problems/container-with-most-water/description/

> 内容描述

```
Given n non-negative integers a1, a2, ..., an , where each represents a point at coordinate (i, ai). n vertical lines are drawn such that the two endpoints of line i is at (i, ai) and (i, 0). Find two lines, which together with x-axis forms a container, such that the container contains the most water.

Note: You may not slant the container and n is at least 2.
```
![img](https://s3-lc-upload.s3.amazonaws.com/uploads/2018/07/17/question_11.jpg)
```
The above vertical lines are represented by array [1,8,6,2,5,4,8,3,7]. In this case, the max area of water (blue section) the container can contain is 49.
```

```
Example:

Input: [1,8,6,2,5,4,8,3,7]
Output: 49
```

## 解题方案

> 对撞指针
******- 时间复杂度: O(N)******- 空间复杂度: O(1)******

* 从数组两层对向查找，直到找到最大乘积

代码：

```javascript
var maxArea = function (list) {
    let i = 0,j = list.length -1,result = 0;
    while(i < j){
        result = Math.max(result ,(j - i ) * Math.min(list[i],list[j]))
        if(list[i] < list[j]){
            i++;
        }else{
            j--;
        }
    }
    return result;
};
```

> 暴力解法
******- 时间复杂度: O(N²)******- 空间复杂度: O(1)******

代码

```javascript
var maxArea = function (list) {
    let result = 0;
    for(let i = 0,len = list.length; i<len; i++){
        for(let j = i+1; j<len; j++){
            let x = (j - i);
            let y = Math.min(list[i],list[j]);
            result = Math.max(result,x*y)
        }
    }
    return result;
};
```